tigase.xmpp.impl

## Class MobileV1

- java.lang.Object
- - tigase.xmpp.XMPPProcessor
  - - tigase.xmpp.impl.MobileV1

- All Implemented Interfaces:
    Comparable<XMPPImplIfc>, ClientStateIndication.Logic, XMPPImplIfc, XMPPPacketFilterIfc, XMPPProcessorIfc

      public class MobileV1
      extends XMPPProcessor
      implements XMPPProcessorIfc, ClientStateIndication.Logic

  Class responsible for queuing packets (usable in connections from mobile clients - power usage optimization) version 1
  Author:
    andrzej

- - ### Field Summary

    - ### Fields inherited from class tigase.xmpp.XMPPProcessor

      `ALL_NAMES, ALL_PATHS, cmpInfo`

    - ### Fields inherited from interface tigase.xmpp.XMPPImplIfc

      `CLIENT_XMLNS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MobileV1()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `activate(XMPPResourceConnection session, Queue<Packet> results)`
    `void` | `deactivate(XMPPResourceConnection session, Queue<Packet> results)`
    `void` | `filter(Packet _packet, XMPPResourceConnection sessionFromSM, NonAuthUserRepository repo, Queue<Packet> results)`
    `boolean` | `filter(XMPPResourceConnection session, Packet res, Queue<Packet> queue)` Method description
    `protected void` | `flushQueue(XMPPResourceConnection session, Queue<Packet> results)`
    `String` | `id()` Method `id` returns a unique ID of the plugin.
    `void` | `init(Map<String,Object> settings)` Method `init` is called just after the plugin has been loaded into memory.
    `protected boolean` | `isQueueEnabled(XMPPResourceConnection session)` Check if queuing is enabled
    `protected boolean` | `isTimedOut(XMPPResourceConnection session)` Check timeout for queue
    `void` | `process(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)`
    `String[][]` | `supElementNamePaths()` Method `supElementNamePaths` returns an array of element names in form of a full path to the XML element for stanzas which can be processed by this plugin.
    `String[]` | `supNamespaces()` Method `supNamespaces` returns an array of name-spaces for stanzas which can be processed by this plugin.
    `Element[]` | `supStreamFeatures(XMPPResourceConnection session)` Method `supStreamFeatures` returns an array of XML `Element`s with stream features which have to be returned to the client uppon request.
    `protected void` | `updateLastAccessTime(XMPPResourceConnection session)` Update last send time

    - ### Methods inherited from class tigase.xmpp.XMPPProcessor

      `canHandle, compareTo, concurrentThreadsPerQueue, getComponentInfo, getInstance, getStatistics, isSupporting, supDiscoFeatures, supElements, supTypes, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface tigase.xmpp.XMPPImplIfc

      `canHandle, concurrentQueuesNo, concurrentThreadsPerQueue, getComponentInfo, getStatistics, isSupporting, supDiscoFeatures, supElements, supTypes`

    - ### Methods inherited from interface java.lang.Comparable

      `compareTo`

- - ### Constructor Detail

    - #### MobileV1

          public MobileV1()

  - ### Method Detail

    - #### id

          public String id()

      Description copied from interface: `XMPPImplIfc`
      Method `id` returns a unique ID of the plugin. Each plugin has own, unique ID which is used in the configuration file to determine whether it needs to be loaded or not. In most cases the ID can be equal to XMLNS of the packages processed by the plugin.
      Specified by:
        `id` in interface `XMPPImplIfc`
      Returns:
        a `String` value

    - #### init

          public void init(Map<String,Object> settings)
                    throws TigaseDBException

      Description copied from interface: `XMPPImplIfc`
      Method `init` is called just after the plugin has been loaded into memory. The idea behind this is to allow it to initialize or check the database. This might be especially useful for plugins which want to have a database access via non-standard stored procedures or need schema upgrade.
      Specified by:
        `init` in interface `XMPPImplIfc`
      Overrides:
        `init` in class `XMPPProcessor`
      Parameters:
        `settings` - is a Map with initial processor settings from the configuration file.
      Throws:
        `TigaseDBException`

    - #### process

          public void process(Packet packet,
                              XMPPResourceConnection session,
                              NonAuthUserRepository repo,
                              Queue<Packet> results,
                              Map<String,Object> settings)

      Specified by:
        `process` in interface `XMPPProcessorIfc`
      Parameters:
        `packet` - packet is which being processed. This parameter may never be null. Even though this is not immutable object it mustn't be altered. None of it's fields or attributes can be changed during processing.
        `session` - user session which keeps all the user session data and also gives an access to the user's repository data. It allows for storing information in a permanent storage or in memory only during the live of the online session. This parameter can be null if there is no online user session at the time of the packet processing.
        `repo` - this is a user data storage which is normally used when the user session (parameter above) is null. This is repository allows for a very restricted access only. It allows for storing some user private data (doesn't allow overwriting existing data) like messages for offline users and it also allows for reading user public data like VCard.
        `results` - this a collection with packets which have been generated as input packet processing results. Regardless a response to a user request is sent or the packet is forwarded to it's destination it is always required that a copy of the input packet is created and stored in the results queue.
        `settings` - this map keeps plugin specific settings loaded from the Tigase server configuration. In most cases it is unused, however if the plugin needs to access an external database that this is a way to pass database connection string to the plugin.

    - #### supElementNamePaths

          public String[][] supElementNamePaths()

      Description copied from interface: `XMPPImplIfc`
      Method `supElementNamePaths` returns an array of element names in form of a full path to the XML element for stanzas which can be processed by this plugin. Each element name path corresponds to XMLNS returned in array by `supNamespaces()` method. The element path itself is represented by a String array with each path element as a separate String.
      Specified by:
        `supElementNamePaths` in interface `XMPPImplIfc`
      Overrides:
        `supElementNamePaths` in class `XMPPProcessor`
      Returns:
        a `String[][]` value is an array for element paths for which the plugin offers processing capabilities. Each path is in form of a String array in order to reduce parsing overhead.

    - #### supNamespaces

          public String[] supNamespaces()

      Description copied from interface: `XMPPImplIfc`
      Method `supNamespaces` returns an array of name-spaces for stanzas which can be processed by this plugin. Each namespace corresponds to element name returned in array by `supElemenets()` method.
      Specified by:
        `supNamespaces` in interface `XMPPImplIfc`
      Overrides:
        `supNamespaces` in class `XMPPProcessor`
      Returns:
        a `String[]` value

    - #### supStreamFeatures

          public Element[] supStreamFeatures(XMPPResourceConnection session)

      Description copied from interface: `XMPPImplIfc`
      Method `supStreamFeatures` returns an array of XML `Element`s with stream features which have to be returned to the client uppon request. Stream features returned by this method correspond to features supported by this plugin.
      Specified by:
        `supStreamFeatures` in interface `XMPPImplIfc`
      Overrides:
        `supStreamFeatures` in class `XMPPProcessor`
      Parameters:
        `session` - a `XMPPResourceConnection` value
      Returns:
        an `Element[]` value

    - #### activate

          public void activate(XMPPResourceConnection session,
                               Queue<Packet> results)

      Specified by:
        `activate` in interface `ClientStateIndication.Logic`

    - #### deactivate

          public void deactivate(XMPPResourceConnection session,
                                 Queue<Packet> results)

      Specified by:
        `deactivate` in interface `ClientStateIndication.Logic`

    - #### filter

          public void filter(Packet _packet,
                             XMPPResourceConnection sessionFromSM,
                             NonAuthUserRepository repo,
                             Queue<Packet> results)

      Specified by:
        `filter` in interface `XMPPPacketFilterIfc`

    - #### filter

          public boolean filter(XMPPResourceConnection session,
                                Packet res,
                                Queue<Packet> queue)

      Method description
      Parameters:
        `session` -
        `res` -
        `queue` -

    - #### flushQueue

          protected void flushQueue(XMPPResourceConnection session,
                                    Queue<Packet> results)

    - #### isQueueEnabled

          protected boolean isQueueEnabled(XMPPResourceConnection session)

      Check if queuing is enabled
      Parameters:
        `session` -

    - #### isTimedOut

          protected boolean isTimedOut(XMPPResourceConnection session)

      Check timeout for queue
      Parameters:
        `session` -

    - #### updateLastAccessTime

          protected void updateLastAccessTime(XMPPResourceConnection session)

      Update last send time
      Parameters:
        `session` -

Copyright © 2022 "Tigase, Inc.". All rights reserved.